{ 楤 ⥭ ᥪ  TR-DOS ᪥ ଠ஢ 㫥  }
{ ᨫ쭮 ஡ ,  ⠭⭠  室 ᪮쪨 ஢ }
{ Andy First, Doctor Max, Mihal Soft                          客 堨 }

unit ZX_Disk;

interface

const
  {  訡 }
  eOk=0;
  eBadController =1;
  eTimeOut       =2;
  eSeekError     =3;
  eDriveNotReady =4;
  eEndOfCylinder =5;
  eBadSector     =6;
  eDMAError      =7;
  eSectorNotFound=8;
  eWriteProtect  =9;
  eUnknownError  =10;

type

  TFDDtype=(DD5,HD5,DD3,HD3);

  PDriveParams=^TDriveParams;
  TDriveParams=Record
    GPL, GPLF: Byte;
    EOT: 1..26;
    FillByte: Byte;
    FDDtype: TFDDtype;
    SectorSize: 1..8;
    HUT: 0..15;
    SRT: 0..15;
    HLT: 0..127;
  end;

  TOpResult=Record
    ST0, ST1, ST2, ST3, C, H, R, N: Byte;
  end;

var IOError: Byte;
    OpResult: TOpResult;

procedure GetFDDRes; { 樠   墠 ᮢ ஫ }
procedure FreeFDDRes; {  ᮢ BIOS }

procedure StartDrive(Drive: Byte);

procedure SetDriveParams(Params: PDriveParams);

Procedure Recalibrate(Drive: Byte);
Procedure Seek(Drive,Track: Byte);
Procedure ReadSector(Buf: pointer; Drive,Track,Head,Sector, Quant: Byte);
Procedure ResetController;

implementation

uses Dos, Crt;

const
  MainStat=$3f2;      { 騩 ॣ ﭨ }
  ContStat=$3f4;      {  ﭨ ஫ }
  ContData=$3f5;      {   ஫ }

  MaxDataSize=256*16; {512*18 ᨬ ࠧ 뢠  }

type
  TBuffer= ARRAY[0..MaxDataSize*2-1] OF Byte;
  PBuffer=^TBuffer;

var
  DriveParams, InternalDriveParams: PDriveParams;
  Buffer, BufBegin: PBuffer;
  DMAPage, DMAOfs: Word;

{-------------------------------------------------------}
Function TestBit(Num, Bit: Byte): Boolean;
const  Bits: ARRAY[0..7] OF Word = (1,2,4,8,16,32,64,128);
begin
  TestBit:=(Num AND Bits[Bit])<>0;
end;

{楤    ஫ FD}
Function In_FDC: Byte;
 var InB:byte;
begin
 asm
     mov  dx, 3F4h
   @WaitBit7i:
     in   al, dx
     test al, 80h
     jz   @WaitBit7i
     inc  dx
     in   al, dx
     mov  InB, al
 end;
 In_FDC:=InB;
end;

{楤 뢮   ஫ FD}
Procedure Out_FDC(OutB: Byte); assembler;
asm
     mov  dx, 3F4h
   @WaitBit7o:
     in   al, dx
     test al, 80h
     jz   @WaitBit7o
     inc  dx
     mov  al, OutB
     out  dx, al
end;

Procedure ReadResult;
begin
  OpResult.ST0:=In_FDC;
  OpResult.ST1:=In_FDC;
  OpResult.ST2:=In_FDC;
  OpResult.C:=In_FDC;
  OpResult.H:=In_FDC;
  OpResult.R:=In_FDC;
  OpResult.N:=In_FDC;
end;

Function SenseInterruptStatus: Byte;
VAR PCN : Byte;
Begin
  Out_FDC($08);
  OpResult.ST0:=In_FDC;
  SenseInterruptStatus:=OpResult.ST0;
  PCN:=In_FDC;
End;

Procedure WaitInterrupt;
 var timer:word;
     WasInt:byte;
begin
  WasInt:=0; timer:=2000;  { 2 sec. }
  While (WasInt=0)AND(Timer>0) DO begin
   dec(timer); delay(1);
   asm
      push DS
      push AX
      xor  AX, AX
      mov  DS, AX
      test byte ptr DS:[43Eh], 80h
      jz   @noInt
      and  byte ptr DS:[43Eh], 7Fh
      mov  WasInt, 1
   @noInt:
      pop  AX
      pop  DS
   end;
  end;
  IF WasInt=0 then IOError:=eTimeOut;
end;

Procedure ResetController;
var i: Integer;
begin
  port[MainStat]:=port[MainStat] AND $FB;
  port[MainStat]:=port[MainStat] OR $04;
  WaitInterrupt;
  FOR i:=0 TO 3 DO
  BEGIN
    IF SenseInterruptStatus<>($c0+i) THEN BEGIN
      IOError:=eBadController;
      Exit;
    END;
  END;
end;


procedure SetDriveParams(Params: PDriveParams);
begin
  IOError:=eOk;
  DriveParams:=Params;
  { ன ᪮ (Specify)  ᪮ । }
  Out_FDC($03);
  WITH DriveParams^ DO
  BEGIN
    Out_FDC(SRT OR (HUT SHL 4));
    Out_FDC(HLT SHL 1);
  END;
  { ⠭ ᪮ ।  DD: 250 kb/s; HD: 500 kb/s }
  IF Params^.FDDtype=HD5 THEN port[$3F7]:=1;
  IF Params^.FDDtype=HD3 THEN port[$3F7]:=2;
  IF Params^.FDDtype=DD5 THEN port[$3F7]:=0; { ? }
  IF Params^.FDDtype=DD3 THEN port[$3F7]:=0;
end;

procedure StartDrive(Drive: Byte);
VAR NewValue, OldValue: Byte;
begin
  IOError:=eOk;
  NewValue:=(1 SHL (Drive+4)) OR Drive OR $0C;
  OldValue:=port[MainStat];
  IF OldValue<>NewValue THEN BEGIN
    port[MainStat]:=NewValue;
    Delay(500);
  END;
end;

procedure GetFDDRes;
var s, o: Word;
  {  祭 㪠⥫ p  稭 Off}
  procedure IncPtr(VAR p: PBuffer; Off: Word);
  begin
    asm
      push      ds
      lds       di,p
      mov       ax,Off
      add       [di],ax
      jnc       @1
      add       word ptr [di+2],1000h
  @1: pop       ds
    end;
  end;
  { ८ࠧ 㪠⥫  ࠭  ᬥ饭  DMA}
  procedure ConvPtr(p: Pointer; VAR Page, Off: Word);
  begin
    asm
      push      ds
      lds       dx,p
      mov       bx,ds
      mov       ax,bx
      mov       cl,4
      shl       ax,cl
      add       ax,dx
      pushf
      lds       di,off
      mov       [di],ax
      mov       ax,bx
      mov       cl,12
      shr       ax,cl
      popf
      jnc        @1
      inc       ax
  @1: lds       di,page
      mov       [di],ax
      pop       ds
    end;
  end;

begin
  IOError:=eOk;
  ResetController;
  IF IOError<>eOk THEN Exit;
{ 뤥   ७  }
  New(Buffer);
  ConvPtr(Buffer, DMAPage, DMAOfs);
  BufBegin:=Buffer;
  IncPtr(BufBegin,MaxDataSize-1);
  ConvPtr(BufBegin, s,o);
  IF s>DMAPage THEN BEGIN
    DMAPage:=s; DMAOfs:=0;
  END;
  BufBegin:=Ptr(DMAPage SHL 12,DMAOfs);
end;

procedure FreeFDDRes;
begin
  IOError:=eOk;
  port[$0A]:=$06;          { ᪨஢ 2  }
  Dispose(Buffer);
end;

Procedure  Recalibrate(Drive: Byte);
VAR Tries: Byte;
begin
  IOError:=eOk;
  StartDrive(Drive);
  FOR Tries:=1 TO 2 DO BEGIN
    Out_FDC($07);
    Out_FDC(Drive);
    WaitInterrupt;         IF IOError<>eOk THEN Exit;
    IF (SenseInterruptStatus AND $10)=0 THEN Exit; {  襭}
    IF IOError<>eOk THEN Exit;
  END;
  IF IOError<>eOk THEN Exit;
  IF (OpResult.ST0 AND $C0) <> 0  THEN IOError:=eSeekError;
end;

Procedure Seek(Drive,Track: Byte);
begin
  IOError:=eOk;
  StartDrive(Drive);
  Out_FDC($0F);
  Out_FDC(Drive);
  Out_FDC(Track);
  WaitInterrupt;         IF IOError<>eOk THEN Exit;
  IF (SenseInterruptStatus AND $C0) <> 0  THEN IOError:=eSeekError;
end;

Procedure ReadSector(Buf: pointer; Drive,Track, Head, Sector, Quant: Byte);
var tmp: Byte;
    BlockSize: Word;
begin
  asm { 稪 [0:440] 騩 ⠭  ᪥ ᨬ 5 ᥪ}
   push DS
   push AX
   xor  AX, AX
   mov  DS, AX
   mov  byte ptr DS:[440h], 90
   pop  AX
   pop  DS
  end;
  IOError:=eOk;
  { ணࠬ஢ DMA }
  BlockSize:=Quant*(128 SHL DriveParams^.SectorSize);
  asm cli end;
  port[$0A]:=$06;                   { ᪨஢ 2  }
  port[$0C]:=$FF;                   {  ਣ }
  port[$04]:=DMAOfs AND $FF;        { ᬥ饭  ࠭ DMA, .  }
  port[$04]:=DMAOfs SHR 8;          { ᬥ饭  ࠭ DMA, .  }
  port[$81]:=DMAPage AND $FF;       { ࠭ DMA }
  port[$05]:=(BlockSize-1) AND $FF; { ࠧ , .  }
  port[$05]:=(BlockSize-1) SHR 8;   { ࠧ , .  }
  port[$0B]:=$46;                   { ०: FDD -> Memory }
  port[$0A]:=$02;                   { ࠧ᪨஢ 2  }
  asm sti end;
  { ନ஢ ਪ }
  Out_FDC($46);
  IF Head>0 THEN Out_FDC(Drive OR $04) ELSE Out_FDC(Drive);
  Out_FDC(Track);
  Out_FDC(0); {Head}
  Out_FDC(Sector);
  Out_FDC(DriveParams^.SectorSize);
  Out_FDC(DriveParams^.EOT);
  Out_FDC(DriveParams^.GPL);
  Out_FDC($FF); { DTL }
  { 믮 }
  WaitInterrupt; IF IOError<>eOk THEN Exit;
  ReadResult;    IF IOError<>eOk THEN Exit;    { 뢠 १⮢ }
  {  १⮢ 樨}
  WITH OpResult DO BEGIN
    IF (ST0 AND $C0) <>0 THEN BEGIN
      IOError:=eUnknownError;
      IF TestBit(ST0,3) THEN IOError:=eDriveNotReady;
      IF TestBit(ST1,7) THEN IOError:=eEndOfCylinder;
      IF TestBit(ST1,5) OR TestBit(ST2,5) OR TestBit(ST2,0) THEN
        IOError:=eBadSector;
      IF TestBit(ST1,2) OR TestBit(ST1,4) THEN IOError:=eSectorNotFound;
      IF TestBit(ST1,4) THEN IOError:=eDMAError;
    END;
  END;
  { ஢  }
  Move(BufBegin^,Buf^,BlockSize);
end;

end.